Index: sys/amd64/amd64/sys_machdep.c
===================================================================
--- sys/amd64/amd64/sys_machdep.c	(.../stable/8)	(revision 201781)
+++ sys/amd64/amd64/sys_machdep.c	(.../projects/capabilities8)	(revision 205872)
@@ -167,6 +167,10 @@
 	uint64_t a64base;
 	struct i386_ioperm_args iargs;
 
+	/*
+	 * XXXRW: As new operations are added here, check that they are safe
+	 * in capability mode.
+	 */
 	if (uap->op == I386_GET_LDT || uap->op == I386_SET_LDT)
 		return (sysarch_ldt(td, uap, UIO_USERSPACE));
 	/*
Index: sys/amd64/amd64/trap.c
===================================================================
--- sys/amd64/amd64/trap.c	(.../stable/8)	(revision 201781)
+++ sys/amd64/amd64/trap.c	(.../projects/capabilities8)	(revision 205872)
@@ -44,6 +44,7 @@
  * AMD64 Trap and System call handling
  */
 
+#include "opt_capabilities.h"
 #include "opt_clock.h"
 #include "opt_cpu.h"
 #include "opt_hwpmc_hooks.h"
@@ -68,6 +69,7 @@
 #include <sys/syscall.h>
 #include <sys/sysctl.h>
 #include <sys/sysent.h>
+#include <sys/ucred.h>
 #include <sys/uio.h>
 #include <sys/vmmeter.h>
 #ifdef KTRACE
@@ -966,7 +968,19 @@
 
 	td->td_syscalls++;
 
+#ifdef CAPABILITIES
+	/*
+	 * In capabilities mode, we only allow access to system calls flagged
+	 * SYF_CAPENABLED.
+	 */
 	if (error == 0) {
+		if (!(callp->sy_flags & SYF_CAPENABLED) &&
+		    (td->td_ucred->cr_flags & CRED_FLAG_CAPMODE))
+			error = ENOSYS;
+	}
+#endif
+
+	if (error == 0) {
 		td->td_retval[0] = 0;
 		td->td_retval[1] = frame->tf_rdx;
 
Index: sys/sys/namei.h
===================================================================
--- sys/sys/namei.h	(.../stable/8)	(revision 201781)
+++ sys/sys/namei.h	(.../projects/capabilities8)	(revision 205872)
@@ -63,6 +63,7 @@
 	 */
 	const	char *ni_dirp;		/* pathname pointer */
 	enum	uio_seg ni_segflg;	/* location of pathname */
+	cap_rights_t ni_rightsneeded;	/* rights required to look up vnode */
 	/*
 	 * Arguments to lookup.
 	 */
@@ -70,7 +71,12 @@
 	struct	vnode *ni_rootdir;	/* logical root directory */
 	struct	vnode *ni_topdir;	/* logical top directory */
 	int	ni_dirfd;		/* starting directory for *at functions */
+	struct	vnode *ni_basedir;	/* root for capability-mode *at */
 	/*
+	 * Results: returned from namei
+	 */
+	cap_rights_t ni_baserights;	/* rights that the *at base has (or -1) */
+	/*
 	 * Results: returned from/manipulated by lookup
 	 */
 	struct	vnode *ni_vp;		/* vnode of result */
@@ -151,11 +157,13 @@
  * Initialization of a nameidata structure.
  */
 #define	NDINIT(ndp, op, flags, segflg, namep, td)			\
-	NDINIT_ALL(ndp, op, flags, segflg, namep, AT_FDCWD, NULL, td)
-#define	NDINIT_AT(ndp, op, flags, segflg, namep, dirfd, td)		\
-	NDINIT_ALL(ndp, op, flags, segflg, namep, dirfd, NULL, td)
-#define	NDINIT_ATVP(ndp, op, flags, segflg, namep, vp, td)		\
-	NDINIT_ALL(ndp, op, flags, segflg, namep, AT_FDCWD, vp, td)
+	NDINIT_ALL(ndp, op, flags, segflg, namep, AT_FDCWD, NULL, NULL, 0, td)
+#define	NDINIT_AT(ndp, op, flags, segflg, namep, dirfd, td)	\
+	NDINIT_ALL(ndp, op, flags, segflg, namep, dirfd, NULL, NULL, 0, td)
+#define	NDINIT_ATRIGHTS(ndp, op, flags, segflg, namep, dirfd, rights, td)	\
+	NDINIT_ALL(ndp, op, flags, segflg, namep, dirfd, NULL, NULL, rights, td)
+#define	NDINIT_ATVP(ndp, op, flags, segflg, namep, vp, td)	\
+	NDINIT_ALL(ndp, op, flags, segflg, namep, AT_FDCWD, vp, NULL, 0, td)
 
 static __inline void
 NDINIT_ALL(struct nameidata *ndp,
@@ -164,6 +172,8 @@
 	const char *namep,
 	int dirfd,
 	struct vnode *startdir,
+	struct vnode *basedir,
+	cap_rights_t rights,
 	struct thread *td)
 {
 	ndp->ni_cnd.cn_nameiop = op;
@@ -172,6 +182,9 @@
 	ndp->ni_dirp = namep;
 	ndp->ni_dirfd = dirfd;
 	ndp->ni_startdir = startdir;
+	ndp->ni_basedir = basedir;
+	ndp->ni_rightsneeded = rights;
+	ndp->ni_baserights = -1;
 	ndp->ni_cnd.cn_thread = td;
 }
 
Index: sys/sys/sysctl.h
===================================================================
--- sys/sys/sysctl.h	(.../stable/8)	(revision 201781)
+++ sys/sys/sysctl.h	(.../projects/capabilities8)	(revision 205872)
@@ -87,6 +87,9 @@
 #define CTLFLAG_MPSAFE	0x00040000	/* Handler is MP safe */
 #define CTLFLAG_VNET	0x00020000	/* Prisons with vnet can fiddle */
 #define CTLFLAG_RDTUN	(CTLFLAG_RD|CTLFLAG_TUN)
+#define CTLFLAG_CAPRD	0x00010000	/* Can be read in capability mode */
+#define CTLFLAG_CAPWR	0x00008000	/* Can be written in capability mode */
+#define CTLFLAG_CAPRW	(CTLFLAG_CAPRD|CTLFLAG_CAPWR)
 
 /*
  * Secure level.   Note that CTLFLAG_SECURE == CTLFLAG_SECURE1.  
@@ -341,7 +344,8 @@
  * kernel features.
  */
 #define	FEATURE(name, desc)						\
-	SYSCTL_INT(_kern_features, OID_AUTO, name, CTLFLAG_RD, 0, 1, desc)
+	SYSCTL_INT(_kern_features, OID_AUTO, name, CTLFLAG_RD |		\
+	    CTLFLAG_CAPRD, 0, 1, desc)
 
 #endif /* _KERNEL */
 
Index: sys/sys/syscall.h
===================================================================
--- sys/sys/syscall.h	(.../stable/8)	(revision 201781)
+++ sys/sys/syscall.h	(.../projects/capabilities8)	(revision 205872)
@@ -428,5 +428,13 @@
 #define	SYS_msgctl	511
 #define	SYS_shmctl	512
 #define	SYS_lpathconf	513
+#define	SYS_cap_new	514
+#define	SYS_cap_getrights	515
+#define	SYS_cap_enter	516
+#define	SYS_cap_getmode	517
+#define	SYS_pdfork	518
+#define	SYS_pdkill	519
+#define	SYS_pdgetpid	520
+#define	SYS_pdwait	521
 #define	SYS_pselect	522
 #define	SYS_MAXSYSCALL	523
Index: sys/sys/filedesc.h
===================================================================
--- sys/sys/filedesc.h	(.../stable/8)	(revision 201781)
+++ sys/sys/filedesc.h	(.../projects/capabilities8)	(revision 205872)
@@ -112,6 +112,8 @@
 int	dupfdopen(struct thread *td, struct filedesc *fdp, int indx, int dfd,
 	    int mode, int error);
 int	falloc(struct thread *td, struct file **resultfp, int *resultfd);
+int	falloc_noinstall(struct thread *td, struct file **resultfp);
+int	finstall(struct thread *td, struct file *fp, int *resultfp);
 int	fdalloc(struct thread *td, int minfd, int *result);
 int	fdavail(struct thread *td, int n);
 int	fdcheckstd(struct thread *td);
@@ -126,6 +128,10 @@
 	filedesc_to_leader_alloc(struct filedesc_to_leader *old,
 	    struct filedesc *fdp, struct proc *leader);
 int	getvnode(struct filedesc *fdp, int fd, struct file **fpp);
+int	getvnode_cap(struct filedesc *fdp, int fd, cap_rights_t rights,
+	    struct file **fpp);
+int	fgetbase(struct thread *td, int fd, cap_rights_t rights,
+	    struct vnode **base);
 void	mountcheckdirs(struct vnode *olddp, struct vnode *newdp);
 void	setugidsafety(struct thread *td);
 
Index: sys/sys/sysproto.h
===================================================================
--- sys/sys/sysproto.h	(.../stable/8)	(revision 201781)
+++ sys/sys/sysproto.h	(.../projects/capabilities8)	(revision 205872)
@@ -1641,6 +1641,37 @@
 	char path_l_[PADL_(char *)]; char * path; char path_r_[PADR_(char *)];
 	char name_l_[PADL_(int)]; int name; char name_r_[PADR_(int)];
 };
+struct cap_new_args {
+	char fd_l_[PADL_(int)]; int fd; char fd_r_[PADR_(int)];
+	char rights_l_[PADL_(u_int64_t)]; u_int64_t rights; char rights_r_[PADR_(u_int64_t)];
+};
+struct cap_getrights_args {
+	char fd_l_[PADL_(int)]; int fd; char fd_r_[PADR_(int)];
+	char rightsp_l_[PADL_(u_int64_t *)]; u_int64_t * rightsp; char rightsp_r_[PADR_(u_int64_t *)];
+};
+struct cap_enter_args {
+	register_t dummy;
+};
+struct cap_getmode_args {
+	char modep_l_[PADL_(u_int *)]; u_int * modep; char modep_r_[PADR_(u_int *)];
+};
+struct pdfork_args {
+	char fdp_l_[PADL_(int *)]; int * fdp; char fdp_r_[PADR_(int *)];
+};
+struct pdkill_args {
+	char fd_l_[PADL_(int)]; int fd; char fd_r_[PADR_(int)];
+	char signum_l_[PADL_(int)]; int signum; char signum_r_[PADR_(int)];
+};
+struct pdgetpid_args {
+	char fd_l_[PADL_(int)]; int fd; char fd_r_[PADR_(int)];
+	char pidp_l_[PADL_(pid_t *)]; pid_t * pidp; char pidp_r_[PADR_(pid_t *)];
+};
+struct pdwait_args {
+	char fd_l_[PADL_(int)]; int fd; char fd_r_[PADR_(int)];
+	char status_l_[PADL_(int *)]; int * status; char status_r_[PADR_(int *)];
+	char options_l_[PADL_(int)]; int options; char options_r_[PADR_(int)];
+	char rusage_l_[PADL_(struct rusage *)]; struct rusage * rusage; char rusage_r_[PADR_(struct rusage *)];
+};
 struct pselect_args {
 	char nd_l_[PADL_(int)]; int nd; char nd_r_[PADR_(int)];
 	char in_l_[PADL_(fd_set *)]; fd_set * in; char in_r_[PADR_(fd_set *)];
@@ -2007,6 +2038,14 @@
 int	msgctl(struct thread *, struct msgctl_args *);
 int	shmctl(struct thread *, struct shmctl_args *);
 int	lpathconf(struct thread *, struct lpathconf_args *);
+int	cap_new(struct thread *, struct cap_new_args *);
+int	cap_getrights(struct thread *, struct cap_getrights_args *);
+int	cap_enter(struct thread *, struct cap_enter_args *);
+int	cap_getmode(struct thread *, struct cap_getmode_args *);
+int	pdfork(struct thread *, struct pdfork_args *);
+int	pdkill(struct thread *, struct pdkill_args *);
+int	pdgetpid(struct thread *, struct pdgetpid_args *);
+int	pdwait(struct thread *, struct pdwait_args *);
 int	pselect(struct thread *, struct pselect_args *);
 
 #ifdef COMPAT_43
@@ -2680,6 +2719,14 @@
 #define	SYS_AUE_msgctl	AUE_MSGCTL
 #define	SYS_AUE_shmctl	AUE_SHMCTL
 #define	SYS_AUE_lpathconf	AUE_LPATHCONF
+#define	SYS_AUE_cap_new	AUE_CAP_NEW
+#define	SYS_AUE_cap_getrights	AUE_CAP_GETRIGHTS
+#define	SYS_AUE_cap_enter	AUE_CAP_ENTER
+#define	SYS_AUE_cap_getmode	AUE_CAP_GETMODE
+#define	SYS_AUE_pdfork	AUE_NULL
+#define	SYS_AUE_pdkill	AUE_NULL
+#define	SYS_AUE_pdgetpid	AUE_NULL
+#define	SYS_AUE_pdwait	AUE_NULL
 #define	SYS_AUE_pselect	AUE_SELECT
 
 #undef PAD_
Index: sys/sys/sysent.h
===================================================================
--- sys/sys/sysent.h	(.../stable/8)	(revision 201781)
+++ sys/sys/sysent.h	(.../projects/capabilities8)	(revision 205872)
@@ -63,6 +63,11 @@
 	u_int32_t sy_flags;	/* General flags for system calls. */
 };
 
+/*
+ * struct sysent flags
+ */
+#define	SYF_CAPENABLED	0x00000001
+
 struct image_params;
 struct __sigset;
 struct trapframe;
Index: sys/sys/user.h
===================================================================
--- sys/sys/user.h	(.../stable/8)	(revision 201781)
+++ sys/sys/user.h	(.../projects/capabilities8)	(revision 205872)
@@ -258,6 +258,7 @@
 #define	KF_TYPE_SHM	8
 #define	KF_TYPE_SEM	9
 #define	KF_TYPE_PTS	10
+#define	KF_TYPE_PROCDESC	12
 #define	KF_TYPE_UNKNOWN	255
 
 #define	KF_VTYPE_VNON	0
@@ -283,6 +284,7 @@
 #define	KF_FLAG_NONBLOCK	0x00000020
 #define	KF_FLAG_DIRECT		0x00000040
 #define	KF_FLAG_HASLOCK		0x00000080
+#define	KF_FLAG_CAPABILITY	0x00000100
 
 /*
  * Old format.  Has variable hidden padding due to alignment.
@@ -330,7 +332,10 @@
 	int	kf_sock_protocol;		/* Socket protocol. */
 	struct sockaddr_storage kf_sa_local;	/* Socket address. */
 	struct sockaddr_storage	kf_sa_peer;	/* Peer address. */
-	int	_kf_ispare[16];			/* Space for more stuff. */
+	pid_t	kf_pid;				/* Process identifier. */
+	int	_kf_ispare0;			/* Space for more stuff. */
+	cap_rights_t	kf_cap_rights;		/* Capability rights. */
+	int	_kf_ispare[12];			/* Space for more stuff. */
 	/* Truncated before copyout in sysctl */
 	char	kf_path[PATH_MAX];		/* Path to file, if any. */
 };
Index: sys/sys/capability.h
===================================================================
--- sys/sys/capability.h	(.../stable/8)	(revision 0)
+++ sys/sys/capability.h	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,209 @@
+/*-
+ * Copyright (c) 2008-2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ * 
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc. 
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $P4: //depot/projects/trustedbsd/capabilities/src/sys/sys/capability.h#29 $
+ */
+
+/*
+ * Definitions for FreeBSD capabilities facility.
+ */
+#ifndef _SYS_CAPABILITY_H_
+#define	_SYS_CAPABILITY_H_
+
+#include <sys/cdefs.h>
+#include <sys/types.h>
+
+/*
+ * Possibly rights on capabilities.
+ */
+#define	CAP_READ		0x0000000000000001ULL	/* read/recv */
+#define	CAP_WRITE		0x0000000000000002ULL	/* write/send */
+#define	CAP_SEEK		0x0000000000000004ULL	/* lseek, various io */
+#define	CAP_GETPEERNAME		0x0000000000000008ULL	/* getpeername */
+#define	CAP_GETSOCKNAME		0x0000000000000010ULL	/* getsockname */
+#define	CAP_FCHFLAGS		0x0000000000000020ULL	/* fchflags */
+#define	CAP_IOCTL		0x0000000000000040ULL	/* ioctl */
+#define	CAP_FSTAT		0x0000000000000080ULL	/* fstat, faccessat */
+#define	CAP_MMAP		0x0000000000000100ULL	/* mmap */
+#define	CAP_FCNTL		0x0000000000000200ULL	/* fcntl */
+#define	CAP_EVENT		0x0000000000000400ULL	/* select/poll */
+#define	CAP_FSYNC		0x0000000000000800ULL	/* fsync */
+#define	CAP_FCHOWN		0x0000000000001000ULL	/* fchown */
+#define	CAP_FCHMOD		0x0000000000002000ULL	/* fchmod */
+#define	CAP_FTRUNCATE		0x0000000000004000ULL	/* ftruncate */
+#define	CAP_FLOCK		0x0000000000008000ULL	/* flock */
+#define	CAP_FSTATFS		0x0000000000010000ULL	/* fstatfs */
+#define	CAP_REVOKE		0x0000000000020000ULL	/* revoke */
+#define	CAP_FEXECVE		0x0000000000040000ULL	/* fexecve */
+#define	CAP_FPATHCONF		0x0000000000080000ULL	/* fpathconf */
+#define	CAP_FUTIMES		0x0000000000100000ULL	/* futimes */
+#define	CAP_ACL_GET		0x0000000000200000ULL	/* acl_get_fd */
+#define	CAP_ACL_SET		0x0000000000400000ULL	/* acl_set_fd */
+#define	CAP_ACL_DELETE		0x0000000000800000ULL	/* acl_delete_fd */
+#define	CAP_ACL_CHECK		0x0000000001000000ULL	/* acl_list_fd */
+#define	CAP_EXTATTR_GET		0x0000000002000000ULL	/* extattr_get_fd */
+#define	CAP_EXTATTR_SET		0x0000000004000000ULL	/* extattr_set_fd */
+#define	CAP_EXTATTR_DELETE	0x0000000008000000ULL	/* extattr_delete_fd */
+#define	CAP_EXTATTR_LIST	0x0000000010000000ULL	/* extattr_list_fd */
+#define	CAP_MAC_GET		0x0000000020000000ULL	/* mac_get_fd */
+#define	CAP_MAC_SET		0x0000000040000000ULL	/* mac_set_fd */
+#define	CAP_ACCEPT		0x0000000080000000ULL	/* accept */
+#define	CAP_CONNECT		0x0000000100000000ULL	/* connect/sendto */
+#define	CAP_BIND		0x0000000200000000ULL	/* bind */
+#define	CAP_GETSOCKOPT		0x0000000400000000ULL	/* getsockopt */
+#define	CAP_SETSOCKOPT		0x0000000800000000ULL	/* setsockopt */
+#define	CAP_LISTEN		0x0000001000000000ULL	/* listen */
+#define	CAP_SHUTDOWN		0x0000002000000000ULL	/* shutdown */
+#define	CAP_PEELOFF		0x0000004000000000ULL	/* sctp_peeloff */
+#define	CAP_LOOKUP		0x0000008000000000ULL	/* _at(2) lookup */
+#define	CAP_SEM_POST		0x0000010000000000ULL	/* ksem_post */
+#define	CAP_SEM_WAIT		0x0000020000000000ULL	/* ksem_wait */
+#define	CAP_SEM_GETVALUE	0x0000040000000000ULL	/* ksem_getvalue */
+#define	CAP_KEVENT		0x0000080000000000ULL	/* kevent(2) */
+#define	CAP_PDGETPID		0x0000100000000000ULL	/* pdgetpid(2) */
+#define	CAP_PDWAIT		0x0000200000000000ULL	/* pdwait(2) */
+#define	CAP_PDKILL		0x0000400000000000ULL	/* pdkill(2) */
+#define	CAP_MAPEXEC		0x0000800000000000ULL	/* mmap(2) as exec */
+#define	CAP_TTYHOOK		0x0001000000000000ULL	/* register tty hook */
+#define	CAP_FCHDIR		0x0002000000000000ULL	/* fchdir(2) */
+#define	CAP_FSCK		0x0004000000000000ULL	/* sysctl_ffs_fsck */
+#define	CAP_ATBASE		0x0008000000000000ULL	/* openat(2), etc. */
+#define CAP_ABSOLUTEPATH	0x0010000000000000ULL	/* abs. lookup from '/' */
+#define CAP_CREATE		0x0020000000000000ULL	/* open, rename, etc. */
+#define CAP_DELETE		0x0040000000000000ULL	/* rename, remove, etc. */
+#define CAP_MKDIR		0x0080000000000000ULL	/* mkdirat(2), mknodat(2) */
+#define CAP_RMDIR		0x0100000000000000ULL	/* rmdirat(2) */
+#define CAP_MKFIFO		0x0200000000000000ULL	/* mkfifoat(2) */
+#define	CAP_MASK_VALID		0x03ffffffffffffffULL
+
+/*
+ * Notes:
+ *
+ * Some system calls don't require a capability in order to perform an
+ * operation on an fd.  These include: close, dup, dup2.
+ *
+ * CAP_SEEK is used alone for lseek, but along-side CAP_READ and CAP_WRITE
+ * for various I/O calls, such as read/write/send/receive.
+ *
+ * pread and pwrite will not use CAP_SEEK.
+ *
+ * CAP_EVENT covers select, poll, and kqueue registration for a capability;
+ * CAP_KEVENT controls the use of a kqueue(2) description.
+ *
+ * sendfile is authorized using CAP_READ on the file and CAP_WRITE on the
+ * socket.
+ *
+ * sendto should check CAP_CONNECT as well as CAP_WRITE if an address is
+ * specified.
+ *
+ * mmap() and aio*() system calls will need special attention as they may
+ * involve reads or writes depending a great deal on context.
+ *
+ * Socket checks don't generally pass CAP_SEEK but perhaps should?
+ */
+
+/*
+ * A mask of multiple capabilities useful for situation where a socket will
+ * be used in a general-purpose way by the kernel, such as a socket used by
+ * the NFS server.
+ */
+#define	CAP_SOCK_ALL	(CAP_READ | CAP_WRITE | CAP_SEEK | CAP_GETPEERNAME | \
+			    CAP_GETSOCKNAME | CAP_IOCTL | CAP_FSTAT | \
+			    CAP_FCNTL | CAP_EVENT | CAP_ACCEPT | \
+			    CAP_CONNECT | CAP_BIND | CAP_GETSOCKOPT | \
+			    CAP_SETSOCKOPT | CAP_LISTEN | CAP_SHUTDOWN | \
+			    CAP_PEELOFF)
+
+#ifdef _KERNEL
+struct file;
+struct thread;
+
+#define IN_CAPABILITY_MODE(td) (td->td_ucred->cr_flags & CRED_FLAG_CAPMODE)
+
+
+/*
+ * Create a capability to wrap a file object.
+ */
+int kern_capwrap(struct thread *td, struct file *fp, cap_rights_t rights,
+                 struct file **cap, int *capfd);
+
+/*
+ * Given a file descriptor that may be a capability, check the requested
+ * rights and extract the underlying object.  Assumes a valid reference is
+ * held to fp_cap, and returns a pointer via fpp under that assumption.  The
+ * caller invokes fhold(*fpp) if required.
+ */
+int	cap_fextract(struct file *fp_cap, cap_rights_t rights,
+	    struct file **fpp);
+int	cap_fextract_mmap(struct file *fp_cap, cap_rights_t rights,
+	    u_char *maxprotp, struct file **fpp);
+
+/*
+ * For the purposes of procstat(1) and similar tools, allow kern_descrip.c to
+ * extract the rights from a capability.  However, this should not be used by
+ * kernel code generally, instead cap_fextract() should be used in order to
+ * keep all access control in one place.
+ */
+cap_rights_t	cap_rights(struct file *fp_cap);
+
+#else /* !_KERNEL */
+
+__BEGIN_DECLS
+/*
+ * cap_enter(): Cause the process to enter capability mode, which will
+ * prevent it from directly accessing global namespaces.  System calls will
+ * be limited to process-local, process-inherited, or file descriptor
+ * operations.  If already in capability mode, a no-op.
+ *
+ * Currently, process-inherited operations are not properly handled -- in
+ * particular, we're interested in things like waitpid(2), kill(2), etc,
+ * being properly constrained.  One possible solution is to introduce process
+ * descriptors.
+ */
+int	cap_enter(void);
+
+/*
+ * cap_new(): Create a new capability derived from an existing file
+ * descriptor with the specified rights.  If the existing file descriptor is
+ * a capability, then the new rights must be a subset of the existing rights.
+ */
+int	cap_new(int fd, cap_rights_t rights);
+
+/*
+ * cap_getrights(): Query the rights on a capability.
+ */
+int	cap_getrights(int fd, cap_rights_t *rightsp);
+__END_DECLS
+
+#endif /* !_KERNEL */
+
+#endif /* !_SYS_CAPABILITY_H_ */

Index: sys/sys/_types.h
===================================================================
--- sys/sys/_types.h	(.../stable/8)	(revision 201781)
+++ sys/sys/_types.h	(.../projects/capabilities8)	(revision 205872)
@@ -38,6 +38,7 @@
 typedef	__uint32_t	__blksize_t;	/* file block size */
 typedef	__int64_t	__blkcnt_t;	/* file block count */
 typedef	__int32_t	__clockid_t;	/* clock_gettime()... */
+typedef	__uint64_t	__cap_rights_t;	/* capability rights */
 typedef	__uint32_t	__fflags_t;	/* file flags */
 typedef	__uint64_t	__fsblkcnt_t;
 typedef	__uint64_t	__fsfilcnt_t;
Index: sys/sys/proc.h
===================================================================
--- sys/sys/proc.h	(.../stable/8)	(revision 201781)
+++ sys/sys/proc.h	(.../projects/capabilities8)	(revision 205872)
@@ -162,6 +162,7 @@
 struct kaioinfo;
 struct p_sched;
 struct proc;
+struct procdesc;
 struct sleepqueue;
 struct thread;
 struct trapframe;
@@ -513,6 +514,7 @@
 	int		p_boundary_count;/* (c) Num threads at user boundary */
 	int		p_pendingcnt;	/* how many signals are pending */
 	struct itimers	*p_itimers;	/* (c) POSIX interval timers. */
+	struct procdesc	*p_procdesc;	/* (e) Process descriptor, if any. */
 /* End area that is zeroed on creation. */
 #define	p_endzero	p_magic
 
@@ -813,6 +815,8 @@
 void	procinit(void);
 void	proc_linkup0(struct proc *p, struct thread *td);
 void	proc_linkup(struct proc *p, struct thread *td);
+void	proc_reap(struct thread *td, struct proc *p, int *status,
+	    int options, struct rusage *rusage);
 void	proc_reparent(struct proc *child, struct proc *newparent);
 struct	pstats *pstats_alloc(void);
 void	pstats_fork(struct pstats *src, struct pstats *dst);
Index: sys/sys/unistd.h
===================================================================
--- sys/sys/unistd.h	(.../stable/8)	(revision 201781)
+++ sys/sys/unistd.h	(.../projects/capabilities8)	(revision 205872)
@@ -180,8 +180,9 @@
 #define	RFLINUXTHPN	(1<<16)	/* do linux clone exit parent notification */
 #define	RFSTOPPED	(1<<17)	/* leave child in a stopped state */
 #define	RFHIGHPID	(1<<18)	/* use a pid higher than 10 (idleproc) */
+#define	RFPROCDESC	(1<<19)	/* return a process descriptor */
 #define	RFPPWAIT	(1<<31)	/* parent sleeps until child exits (vfork) */
-#define	RFKERNELONLY	(RFSTOPPED | RFHIGHPID | RFPPWAIT)
+#define	RFKERNELONLY	(RFSTOPPED | RFHIGHPID | RFPPWAIT | RFPROCDESC)
 
 #endif /* __BSD_VISIBLE */
 
Index: sys/sys/syscall.mk
===================================================================
--- sys/sys/syscall.mk	(.../stable/8)	(revision 201781)
+++ sys/sys/syscall.mk	(.../projects/capabilities8)	(revision 205872)
@@ -377,4 +377,12 @@
 	msgctl.o \
 	shmctl.o \
 	lpathconf.o \
+	cap_new.o \
+	cap_getrights.o \
+	cap_enter.o \
+	cap_getmode.o \
+	pdfork.o \
+	pdkill.o \
+	pdgetpid.o \
+	pdwait.o \
 	pselect.o
Index: sys/sys/types.h
===================================================================
--- sys/sys/types.h	(.../stable/8)	(revision 201781)
+++ sys/sys/types.h	(.../projects/capabilities8)	(revision 205872)
@@ -133,6 +133,8 @@
 #define	_BLKCNT_T_DECLARED
 #endif
 
+typedef	__cap_rights_t	cap_rights_t;
+
 #ifndef _CLOCK_T_DECLARED
 typedef	__clock_t	clock_t;
 #define	_CLOCK_T_DECLARED
Index: sys/sys/procdesc.h
===================================================================
--- sys/sys/procdesc.h	(.../stable/8)	(revision 0)
+++ sys/sys/procdesc.h	(.../projects/capabilities8)	(revision 205872)
@@ -0,0 +1,115 @@
+/*-
+ * Copyright (c) 2009 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * WARNING: THIS IS EXPERIMENTAL SECURITY SOFTWARE THAT MUST NOT BE RELIED
+ * ON IN PRODUCTION SYSTEMS.  IT WILL BREAK YOUR SOFTWARE IN NEW AND
+ * UNEXPECTED WAYS.
+ *
+ * This software was developed at the University of Cambridge Computer
+ * Laboratory with support from a grant from Google, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _SYS_PROCDESC_H_
+#define	_SYS_PROCDESC_H_
+
+#ifdef _KERNEL
+#include <sys/selinfo.h>	/* struct selinfo */
+#include <sys/_lock.h>
+#include <sys/_mutex.h>
+
+/*-
+ * struct procdesc describes a process descriptor, and essentially consists
+ * of two pointers -- one to the file descriptor, and one to the process.
+ * When both become NULL, the process descriptor will be freed.  An important
+ * invariant is that there is only ever one process descriptor for a process,
+ * so a single file pointer will suffice.
+ *
+ * Locking key:
+ * (c) - Constant after initial setup.
+ * (p) - Protected by the process descriptor mutex.
+ * (r) - Atomic eference count.
+ * (s) - Protected by selinfo.
+ * (t) - Protected by the proctree_lock
+ */
+struct proc;
+struct sigio;
+struct procdesc {
+	/*
+	 * Basic process descriptor state: the process, a cache of its pid to
+	 * satisfy queries after the process exits, and process descriptor
+	 * refcount.
+	 */
+	struct proc	*pd_proc;		/* (t) Process. */
+	pid_t		 pd_pid;		/* (c) Cached pid. */
+	u_int		 pd_refcount;		/* (r) Reference count. */
+
+	/*
+	 * In-flight data and notification of events.
+	 */
+	int		 pd_flags;		/* (p) PD_ flags. */
+	struct selinfo	 pd_selinfo;		/* (p) Event notification. */
+	struct mtx	 pd_lock;		/* Protect data + events. */
+};
+
+/*
+ * Locking macros for the procdesc itself.
+ */
+#define	PROCDESC_LOCK_DESTROY(pd)	mtx_destroy(&(pd)->pd_lock)
+#define	PROCDESC_LOCK_INIT(pd)	mtx_init(&(pd)->pd_lock, "procdesc", NULL, \
+				    MTX_DEF)
+#define	PROCDESC_LOCK(pd)	mtx_lock(&(pd)->pd_lock)
+#define	PROCDESC_UNLOCK(pd)	mtx_unlock(&(pd)->pd_lock)
+
+/*
+ * Flags for the pd_flags field.
+ */
+#define	PD_CLOSED	0x00000001	/* Descriptor has closed. */
+#define	PD_SELECTED	0x00000002	/* Issue selwakeup(). */
+#define	PD_EXITED	0x00000004	/* Process exited. */
+
+/*
+ * In-kernel interfaces to process descriptors.
+ */
+int	 procdesc_exit(struct proc *p);
+int	 procdesc_find(struct thread *td, int fd, cap_rights_t rights,
+	    struct proc **p);
+void	 procdesc_new(struct proc *p, struct file *fp_procdesc);
+pid_t	 procdesc_pid(struct file *fp_procdesc);
+void	 procdesc_reap(struct proc *p);
+
+#else /* !_KERNEL */
+
+/*
+ * Process descriptor system calls.
+ */
+struct rusage;
+int	pdfork(int *fdp);
+int	pdkill(int fd, int signum);
+int	pdgetpid(int fd, pid_t *pidp);
+int	pdwait4(int fd, int *status, int options, struct rusage *rusage);
+
+#endif /* _KERNEL */
+
+#endif /* !_SYS_PROCDESC_H_ */

Index: sys/sys/ucred.h
===================================================================
--- sys/sys/ucred.h	(.../stable/8)	(revision 201781)
+++ sys/sys/ucred.h	(.../projects/capabilities8)	(revision 205872)
@@ -68,6 +68,10 @@
 #endif /* _KERNEL || _WANT_UCRED */
 
 #define	XU_NGROUPS	16
+/*
+ * Flags for cr_flags.
+ */
+#define	CRED_FLAG_CAPMODE	0x00000001	/* In capability mode. */
 
 /*
  * This is the external representation of struct ucred.
Index: sys/sys/file.h
===================================================================
--- sys/sys/file.h	(.../stable/8)	(revision 201781)
+++ sys/sys/file.h	(.../projects/capabilities8)	(revision 205872)
@@ -36,6 +36,7 @@
 #ifndef _KERNEL
 #include <sys/types.h> /* XXX */
 #include <sys/fcntl.h>
+#include <sys/queue.h>
 #include <sys/unistd.h>
 #else
 #include <sys/queue.h>
@@ -63,6 +64,8 @@
 #define	DTYPE_SHM	8	/* swap-backed shared memory */
 #define	DTYPE_SEM	9	/* posix semaphore */
 #define	DTYPE_PTS	10	/* pseudo teletype master device */
+#define	DTYPE_CAPABILITY	11	/* capability */
+#define	DTYPE_PROCDESC	12	/* process descriptor */
 
 #ifdef _KERNEL
 
@@ -136,6 +139,8 @@
 	 * Mandatory Access control information.
 	 */
 	void		*f_label;	/* Place-holder for MAC label. */
+	LIST_HEAD(, capability)	f_caps;	/* (f) List of capabilities for file. */
+	u_int		 f_capcount;	/* (f) Number of capabilities. */
 };
 
 #define	FOFFSET_LOCKED       0x1
@@ -174,9 +179,14 @@
 extern int maxfilesperproc;	/* per process limit on number of open files */
 extern volatile int openfiles;	/* actual number of open files */
 
-int fget(struct thread *td, int fd, struct file **fpp);
-int fget_read(struct thread *td, int fd, struct file **fpp);
-int fget_write(struct thread *td, int fd, struct file **fpp);
+int fget(struct thread *td, int fd, cap_rights_t rights, struct file **fpp);
+int fget_mmap(struct thread *td, int fd, cap_rights_t rights,
+    u_char *maxprotp, struct file **fpp);
+int fget_read(struct thread *td, int fd, cap_rights_t rights,
+    struct file **fpp);
+int fget_write(struct thread *td, int fd, cap_rights_t rights,
+    struct file **fpp);
+int fgetcap(struct thread *td, int fd, struct file **fpp);
 int _fdrop(struct file *fp, struct thread *td);
 
 /*
@@ -194,11 +204,17 @@
 fo_close_t	soo_close;
 
 void finit(struct file *, u_int, short, void *, struct fileops *);
-int fgetvp(struct thread *td, int fd, struct vnode **vpp);
-int fgetvp_read(struct thread *td, int fd, struct vnode **vpp);
-int fgetvp_write(struct thread *td, int fd, struct vnode **vpp);
+int fgetvp(struct thread *td, int fd, cap_rights_t rights,
+    struct vnode **vpp);
+int fgetvp_rights(struct thread *td, int fd, cap_rights_t need, cap_rights_t *have,
+    struct vnode **vpp);
+int fgetvp_read(struct thread *td, int fd, cap_rights_t rights,
+    struct vnode **vpp);
+int fgetvp_write(struct thread *td, int fd, cap_rights_t rights,
+    struct vnode **vpp);
 
-int fgetsock(struct thread *td, int fd, struct socket **spp, u_int *fflagp);
+int fgetsock(struct thread *td, int fd, cap_rights_t rights,
+    struct socket **spp, u_int *fflagp);
 void fputsock(struct socket *sp);
 
 #define	fhold(fp)							\

